/******************** (C) COPYRIGHT 2023 GeekRebot *****************************
* File Name          : pid.c
* Current Version    : V1.0  & ST 3.5.0
* Author             : zhanli 719901725@qq.com
* Date of Issued     : 2023.04.06 zhanli: Create
* Comments           : GeekRebotĵPIDƲ
********************************************************************************/
#include "pid.h"

/* ʽpid,PIDغ,趨ԵӰǳ */
float   Proportion = 0.6;                               //  Proportional Const
float   Integral   = 0.1;                               // ֳ Integral Const
float   Derivative = 0;                                 // ΢ֳ Derivative Const

//ʾpidOLED
void showPID(void)
{
	float temp1,temp2,temp3;
	char PID_P[3],PID_I[3],PID_D[3];
	temp1 = Proportion;
	sprintf(PID_P,"%1.1f",temp1);
	OLED_ShowString(16,4, (u8*)PID_P,16);  

	temp2 = Integral;
	sprintf(PID_I,"%1.1f",temp2);
	OLED_ShowString(56,4, (u8*)PID_I,16); 

	temp3 = Derivative;
	sprintf(PID_D,"%1.1f",temp3);
	OLED_ShowString(104,4, (u8*)PID_D,16); 
}

/********************ʽPID************************************/
//NextPointǰֵ
//SetPoint趨ֵ

//PID
int PID_Calc_Left(int NextPoint,int SetPoint) 
{                             
	static int      LastError;                                // Error[-1]
	static int      PrevError;                                // Error[-2]
	int iError,Outpid;                                        // ǰ

	iError=SetPoint-NextPoint;                                // 
	Outpid=(Proportion * iError)                              // E[k]
			  -(Integral * LastError)                         // E[k-1]
			  +(Derivative * PrevError);                      // E[k-2]
			  
	PrevError=LastError;                                      // 洢´μ
	LastError=iError;
	return(Outpid);                                           // ֵ
}


//PID
int PID_Calc_Right(int NextPoint,int SetPoint) 
{                      
	static int LastError;                                     // Error[-1]
	static int PrevError;                                     // Error[-2]
	int iError,Outpid;                                        // ǰ

	iError = SetPoint-NextPoint;                              // 
	Outpid = (Proportion * iError)                            // E[k]
			  -(Integral * LastError)                         // E[k-1]
			  +(Derivative * PrevError);                      // E[k-2]
			  
	PrevError=LastError;                                      // 洢´μ
	LastError=iError;
	return(Outpid);                                           // ֵ
}

